
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android UI-自定义日历控件 / 憋错料</title>

    <meta name="description" content="Android UI-自定义日历控件 Android UI-自定义日历控件 本篇博客笔者给大家分享一个日历控件,这里有个需求:要求显示当前月的日期,左右可以切换月份来查看日期. 我们想一想会如何去实现这样的一个控件,有开源的,但可能不太满足我们的特定的需求,这里笔者自定义了一个,读者可以根据自己的需求来修改代码.下面来说一下实现的思路: 首先我们要显示当前月份,自然我们要计算出当前的日期,并且把每一天对应到具体的星期,我们会有以下效果: 我们先想一下这样的效果用什么控件可以实现?很自然可以想到用网格视图GridView,但这里笔者使">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android UI-自定义日历控件</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>Android UI-自定义日历控件</strong></p>
<p>本篇博客笔者给大家分享一个日历控件，这里有个需求：要求显示当前月的日期，左右可以切换月份来查看日期。</p>
<p>我们想一想会如何去实现这样的一个控件，有开源的，但可能不太满足我们的特定的需求，这里笔者自定义了一个，读者可以根据自己的需求来修改代码。下面来说一下实现的思路：</p>
<p>首先我们要显示当前月份，自然我们要计算出当前的日期，并且把每一天对应到具体的星期，我们会有以下效果：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDEyMjkyMTEwMjAzODA=.jpg" /></p>
<p>我们先想一下这样的效果用什么控件可以实现？很自然可以想到用网格视图GridView，但这里笔者使用的不是GridView, 因为使用GridView可能无法实现那个红色的圈圈，所以笔者决定自定义View，通过绘制来达到这样的效果。</p>
<p>这里我们定于一个日历卡，每一个月代表一个日历卡，我们通过计算每个月的日期，然后根据计算出来的位置绘制我们的数字。</p>
<p>我们知道，一个星期有七天，分别为星期日、星期一、星期二、星期三、星期四、星期五、星期六，这里有7列，一个月至少有28天，最多31天，所以至少应该有6行。组成6*7的方格图。</p>
<p>直接上代码：</p>
<pre>package com.xiaowu.calendar;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewConfiguration;

/**
 * 自定义日历卡
 *
 * @author wuwenjie
 *
 */
public class CalendarCard extends View {

	private static final int TOTAL_COL = 7; // 7列
	private static final int TOTAL_ROW = 6; // 6行

	private Paint mCirclePaint; // 绘制圆形的画笔
	private Paint mTextPaint; // 绘制文本的画笔
	private int mViewWidth; // 视图的宽度
	private int mViewHeight; // 视图的高度
	private int mCellSpace; // 单元格间距
	private Row rows[] = new Row[TOTAL_ROW]; // 行数组，每个元素代表一行
	private static CustomDate mShowDate; // 自定义的日期，包括year,month,day
	private OnCellClickListener mCellClickListener; // 单元格点击回调事件
	private int touchSlop; //
	private boolean callBackCellSpace;

	private Cell mClickCell;
	private float mDownX;
	private float mDownY;

	/**
	 * 单元格点击的回调接口
	 *
	 * @author wuwenjie
	 *
	 */
	public interface OnCellClickListener {
		void clickDate(CustomDate date); // 回调点击的日期

		void changeDate(CustomDate date); // 回调滑动ViewPager改变的日期
	}

	public CalendarCard(Context context, AttributeSet attrs, int defStyleAttr) {
		super(context, attrs, defStyleAttr);
		init(context);
	}

	public CalendarCard(Context context, AttributeSet attrs) {
		super(context, attrs);
		init(context);
	}

	public CalendarCard(Context context) {
		super(context);
		init(context);
	}

	public CalendarCard(Context context, OnCellClickListener listener) {
		super(context);
		this.mCellClickListener = listener;
		init(context);
	}

	private void init(Context context) {
		mTextPaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		mCirclePaint = new Paint(Paint.ANTI_ALIAS_FLAG);
		mCirclePaint.setStyle(Paint.Style.FILL);
		mCirclePaint.setColor(Color.parseColor(&quot;#F24949&quot;)); // 红色圆形
		touchSlop = ViewConfiguration.get(context).getScaledTouchSlop();

		initDate();
	}

	private void initDate() {
		mShowDate = new CustomDate();
		fillDate();//
	}

	private void fillDate() {
		int monthDay = DateUtil.getCurrentMonthDay(); // 今天
		int lastMonthDays = DateUtil.getMonthDays(mShowDate.year,
				mShowDate.month - 1); // 上个月的天数
		int currentMonthDays = DateUtil.getMonthDays(mShowDate.year,
				mShowDate.month); // 当前月的天数
		int firstDayWeek = DateUtil.getWeekDayFromDate(mShowDate.year,
				mShowDate.month);
		boolean isCurrentMonth = false;
		if (DateUtil.isCurrentMonth(mShowDate)) {
			isCurrentMonth = true;
		}
		int day = 0;
		for (int j = 0; j &lt; TOTAL_ROW; j++) {
			rows[j] = new Row(j);
			for (int i = 0; i &lt; TOTAL_COL; i++) {
				int position = i + j * TOTAL_COL; // 单元格位置
				// 这个月的
				if (position &gt;= firstDayWeek
						&amp;&amp; position &lt; firstDayWeek + currentMonthDays) {
					day++;
					rows[j].cells[i] = new Cell(CustomDate.modifiDayForObject(
							mShowDate, day), State.CURRENT_MONTH_DAY, i, j);
					// 今天
					if (isCurrentMonth &amp;&amp; day == monthDay ) {
						CustomDate date = CustomDate.modifiDayForObject(mShowDate, day);
						rows[j].cells[i] = new Cell(date, State.TODAY, i, j);
					}

					if (isCurrentMonth &amp;&amp; day &gt; monthDay) { // 如果比这个月的今天要大，表示还没到
						rows[j].cells[i] = new Cell(
								CustomDate.modifiDayForObject(mShowDate, day),
								State.UNREACH_DAY, i, j);
					}

					// 过去一个月
				} else if (position &lt; firstDayWeek) {
					rows[j].cells[i] = new Cell(new CustomDate(mShowDate.year,
							mShowDate.month - 1, lastMonthDays
									- (firstDayWeek - position - 1)),
							State.PAST_MONTH_DAY, i, j);
					// 下个月
				} else if (position &gt;= firstDayWeek + currentMonthDays) {
					rows[j].cells[i] = new Cell((new CustomDate(mShowDate.year,
							mShowDate.month + 1, position - firstDayWeek
									- currentMonthDays + 1)),
							State.NEXT_MONTH_DAY, i, j);
				}
			}
		}
		mCellClickListener.changeDate(mShowDate);
	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		for (int i = 0; i &lt; TOTAL_ROW; i++) {
			if (rows[i] != null) {
				rows[i].drawCells(canvas);
			}
		}
	}

	@Override
	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		super.onSizeChanged(w, h, oldw, oldh);
		mViewWidth = w;
		mViewHeight = h;
		mCellSpace = Math.min(mViewHeight / TOTAL_ROW, mViewWidth / TOTAL_COL);
		if (!callBackCellSpace) {
			callBackCellSpace = true;
		}
		mTextPaint.setTextSize(mCellSpace / 3);
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {
		switch (event.getAction()) {
		case MotionEvent.ACTION_DOWN:
			mDownX = event.getX();
			mDownY = event.getY();
			break;
		case MotionEvent.ACTION_UP:
			float disX = event.getX() - mDownX;
			float disY = event.getY() - mDownY;
			if (Math.abs(disX) &lt; touchSlop &amp;&amp; Math.abs(disY) &lt; touchSlop) {
				int col = (int) (mDownX / mCellSpace);
				int row = (int) (mDownY / mCellSpace);
				measureClickCell(col, row);
			}
			break;
		default:
			break;
		}

		return true;
	}

	/**
	 * 计算点击的单元格
	 * @param col
	 * @param row
	 */
	private void measureClickCell(int col, int row) {
		if (col &gt;= TOTAL_COL || row &gt;= TOTAL_ROW)
			return;
		if (mClickCell != null) {
			rows[mClickCell.j].cells[mClickCell.i] = mClickCell;
		}
		if (rows[row] != null) {
			mClickCell = new Cell(rows[row].cells[col].date,
					rows[row].cells[col].state, rows[row].cells[col].i,
					rows[row].cells[col].j);

			CustomDate date = rows[row].cells[col].date;
			date.week = col;
			mCellClickListener.clickDate(date);

			// 刷新界面
			update();
		}
	}

	/**
	 * 组元素
	 *
	 * @author wuwenjie
	 *
	 */
	class Row {
		public int j;

		Row(int j) {
			this.j = j;
		}

		public Cell[] cells = new Cell[TOTAL_COL];

		// 绘制单元格
		public void drawCells(Canvas canvas) {
			for (int i = 0; i &lt; cells.length; i++) {
				if (cells[i] != null) {
					cells[i].drawSelf(canvas);
				}
			}
		}

	}

	/**
	 * 单元格元素
	 *
	 * @author wuwenjie
	 *
	 */
	class Cell {
		public CustomDate date;
		public State state;
		public int i;
		public int j;

		public Cell(CustomDate date, State state, int i, int j) {
			super();
			this.date = date;
			this.state = state;
			this.i = i;
			this.j = j;
		}

		public void drawSelf(Canvas canvas) {
			switch (state) {
			case TODAY: // 今天
				mTextPaint.setColor(Color.parseColor(&quot;#fffffe&quot;));
				canvas.drawCircle((float) (mCellSpace * (i + 0.5)),
						(float) ((j + 0.5) * mCellSpace), mCellSpace / 3,
						mCirclePaint);
				break;
			case CURRENT_MONTH_DAY: // 当前月日期
				mTextPaint.setColor(Color.BLACK);
				break;
			case PAST_MONTH_DAY: // 过去一个月
			case NEXT_MONTH_DAY: // 下一个月
				mTextPaint.setColor(Color.parseColor(&quot;#fffffe&quot;));
				break;
			case UNREACH_DAY: // 还未到的天
				mTextPaint.setColor(Color.GRAY);
				break;
			default:
				break;
			}
			// 绘制文字
			String content = date.day + &quot;&quot;;
			canvas.drawText(content,
					(float) ((i + 0.5) * mCellSpace - mTextPaint
							.measureText(content) / 2), (float) ((j + 0.7)
							* mCellSpace - mTextPaint
							.measureText(content, 0, 1) / 2), mTextPaint);
		}
	}

	/**
	 *
	 * @author wuwenjie 单元格的状态 当前月日期，过去的月的日期，下个月的日期
	 */
	enum State {
		TODAY,CURRENT_MONTH_DAY, PAST_MONTH_DAY, NEXT_MONTH_DAY, UNREACH_DAY;
	}

	// 从左往右划，上一个月
	public void leftSlide() {
		if (mShowDate.month == 1) {
			mShowDate.month = 12;
			mShowDate.year -= 1;
		} else {
			mShowDate.month -= 1;
		}
		update();
	}

	// 从右往左划，下一个月
	public void rightSlide() {
		if (mShowDate.month == 12) {
			mShowDate.month = 1;
			mShowDate.year += 1;
		} else {
			mShowDate.month += 1;
		}
		update();
	}

	public void update() {
		fillDate();
		invalidate();
	}

}
</pre>
<p>/CustomCalendarView/src/com/xiaowu/calendar/DateUtil.java</p>
<pre>package com.xiaowu.calendar;

import android.annotation.SuppressLint;
import android.util.Log;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

public class DateUtil {

	public static String[] weekName = { &quot;周日&quot;, &quot;周一&quot;, &quot;周二&quot;, &quot;周三&quot;, &quot;周四&quot;, &quot;周五&quot;,&quot;周六&quot; };

	public static int getMonthDays(int year, int month) {
		if (month &gt; 12) {
			month = 1;
			year += 1;
		} else if (month &lt; 1) {
			month = 12;
			year -= 1;
		}
		int[] arr = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
		int days = 0;

		if ((year % 4 == 0 &amp;&amp; year % 100 != 0) || year % 400 == 0) {
			arr[1] = 29; // 闰年2月29天
		}

		try {
			days = arr[month - 1];
		} catch (Exception e) {
			e.getStackTrace();
		}

		return days;
	}

	public static int getYear() {
		return Calendar.getInstance().get(Calendar.YEAR);
	}

	public static int getMonth() {
		return Calendar.getInstance().get(Calendar.MONTH) + 1;
	}

	public static int getCurrentMonthDay() {
		return Calendar.getInstance().get(Calendar.DAY_OF_MONTH);
	}

	public static int getWeekDay() {
		return Calendar.getInstance().get(Calendar.DAY_OF_WEEK);
	}

	public static int getHour() {
		return Calendar.getInstance().get(Calendar.HOUR_OF_DAY);
	}
	public static int getMinute() {
		return Calendar.getInstance().get(Calendar.MINUTE);
	}
	public static CustomDate getNextSunday() {

		Calendar c = Calendar.getInstance();
		c.add(Calendar.DATE, 7 - getWeekDay()+1);
		CustomDate date = new CustomDate(c.get(Calendar.YEAR),
				c.get(Calendar.MONTH)+1, c.get(Calendar.DAY_OF_MONTH));
		return date;
	}

	public static int[] getWeekSunday(int year, int month, int day, int pervious) {
		int[] time = new int[3];
		Calendar c = Calendar.getInstance();
		c.set(Calendar.YEAR, year);
		c.set(Calendar.MONTH, month);
		c.set(Calendar.DAY_OF_MONTH, day);
		c.add(Calendar.DAY_OF_MONTH, pervious);
		time[0] = c.get(Calendar.YEAR);
		time[1] = c.get(Calendar.MONTH )+1;
		time[2] = c.get(Calendar.DAY_OF_MONTH);
		return time;

	}

	public static int getWeekDayFromDate(int year, int month) {
		Calendar cal = Calendar.getInstance();
		cal.setTime(getDateFromString(year, month));
		int week_index = cal.get(Calendar.DAY_OF_WEEK) - 1;
		if (week_index &lt; 0) {
			week_index = 0;
		}
		return week_index;
	}

	@SuppressLint(&quot;SimpleDateFormat&quot;)
	public static Date getDateFromString(int year, int month) {
		String dateString = year + &quot;-&quot; + (month &gt; 9 ? month : (&quot;0&quot; + month))
				+ &quot;-01&quot;;
		Date date = null;
		try {
			SimpleDateFormat sdf = new SimpleDateFormat(&quot;yyyy-MM-dd&quot;);
			date = sdf.parse(dateString);
		} catch (ParseException e) {
			System.out.println(e.getMessage());
		}
		return date;
	}
	public static boolean isToday(CustomDate date){
		return(date.year == DateUtil.getYear() &amp;&amp;
				date.month == DateUtil.getMonth()
				&amp;&amp; date.day == DateUtil.getCurrentMonthDay());
	}

	public static boolean isCurrentMonth(CustomDate date){
		return(date.year == DateUtil.getYear() &amp;&amp;
				date.month == DateUtil.getMonth());
	}
}
</pre>
<p>/CustomCalendarView/src/com/xiaowu/calendar/CustomDate.java、</p>
<pre>package com.xiaowu.calendar;

import java.io.Serializable;
public class CustomDate implements Serializable{

	private static final long serialVersionUID = 1L;
	public int year;
	public int month;
	public int day;
	public int week;

	public CustomDate(int year,int month,int day){
		if(month &gt; 12){
			month = 1;
			year++;
		}else if(month &lt;1){
			month = 12;
			year--;
		}
		this.year = year;
		this.month = month;
		this.day = day;
	}

	public CustomDate(){
		this.year = DateUtil.getYear();
		this.month = DateUtil.getMonth();
		this.day = DateUtil.getCurrentMonthDay();
	}

	public static CustomDate modifiDayForObject(CustomDate date,int day){
		CustomDate modifiDate = new CustomDate(date.year,date.month,day);
		return modifiDate;
	}
	@Override
	public String toString() {
		return year+&quot;-&quot;+month+&quot;-&quot;+day;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

	public int getMonth() {
		return month;
	}

	public void setMonth(int month) {
		this.month = month;
	}

	public int getDay() {
		return day;
	}

	public void setDay(int day) {
		this.day = day;
	}

	public int getWeek() {
		return week;
	}

	public void setWeek(int week) {
		this.week = week;
	}

}
</pre>
<p>所有绘制的操作在onDraw方面里实现，我这里定于了一个组对象Row、单元格元素Cell，通过Row[row].cell[col]来确定一个单元格，每次调用invalidate重绘视图。</p>
<p>接着，我们有一个需求需要左右切换，我们选用最熟悉的ViewPager，但这里有个问题，怎么实现无限循环呢，</p>
<p>这里我们传入一个日历卡数组，让ViewPager循环复用这几个日历卡，避免消耗内存。</p>
<p>/CustomCalendarView/src/com/xiaowu/calendar/CalendarViewAdapter.java</p>
<pre>package com.xiaowu.calendar;

import android.support.v4.view.PagerAdapter;
import android.support.v4.view.ViewPager;
import android.view.View;
import android.view.ViewGroup;

public class CalendarViewAdapter&lt;V extends View&gt; extends PagerAdapter {
	public static final String TAG = &quot;CalendarViewAdapter&quot;;
	private V[] views;

	public CalendarViewAdapter(V[] views) {
		super();
		this.views = views;
	}

	@Override
	public Object instantiateItem(ViewGroup container, int position) {

		if (((ViewPager) container).getChildCount() == views.length) {
			((ViewPager) container).removeView(views[position % views.length]);
		}

		((ViewPager) container).addView(views[position % views.length], 0);
		return views[position % views.length];
	}

	@Override
	public int getCount() {
		return Integer.MAX_VALUE;
	}

	@Override
	public boolean isViewFromObject(View view, Object object) {
		return view == ((View) object);
	}

	@Override
	public void destroyItem(ViewGroup container, int position, Object object) {
		((ViewPager) container).removeView((View) container);
	}

	public V[] getAllItems() {
		return views;
	}

}
</pre>
<p>布局文件：</p>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;
&lt;LinearLayout xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot;
    xmlns:tools=&quot;http://schemas.android.com/tools&quot;
    android:layout_width=&quot;match_parent&quot;
    android:layout_height=&quot;match_parent&quot;
    android:background=&quot;@color/white&quot;
    android:orientation=&quot;vertical&quot; &gt;

    &lt;RelativeLayout
        android:layout_width=&quot;match_parent&quot;
        android:layout_height=&quot;50dp&quot;
        android:background=&quot;#f6f1ea&quot;
         &gt;

        &lt;ImageButton
            android:id=&quot;@+id/btnPreMonth&quot;
            android:layout_width=&quot;wrap_content&quot;
            android:layout_height=&quot;wrap_content&quot;
            android:layout_centerVertical=&quot;true&quot;
            android:layout_marginRight=&quot;33dip&quot;
            android:layout_toLeftOf=&quot;@+id/tvCurrentMonth&quot;
            android:background=&quot;@drawable/ic_before&quot; /&gt;

        &lt;ImageButton
            android:id=&quot;@+id/btnNextMonth&quot;
            android:layout_width=&quot;wrap_content&quot;
            android:layout_height=&quot;wrap_content&quot;
            android:layout_centerVertical=&quot;true&quot;
            android:layout_marginLeft=&quot;33dip&quot;
            android:layout_toRightOf=&quot;@+id/tvCurrentMonth&quot;
            android:background=&quot;@drawable/ic_next&quot; /&gt;

        &lt;TextView
            android:id=&quot;@+id/tvCurrentMonth&quot;
            android:layout_width=&quot;wrap_content&quot;
            android:layout_height=&quot;wrap_content&quot;
            android:layout_centerInParent=&quot;true&quot;
            android:layout_centerVertical=&quot;true&quot;
            android:text=&quot;11月&quot;
            android:textColor=&quot;#323232&quot;
            android:textSize=&quot;22sp&quot; /&gt;

        &lt;ImageButton
            android:id=&quot;@+id/btnClose&quot;
            android:layout_width=&quot;wrap_content&quot;
            android:layout_height=&quot;wrap_content&quot;
            android:layout_alignParentRight=&quot;true&quot;
            android:layout_centerVertical=&quot;true&quot;
            android:layout_marginRight=&quot;15dp&quot;
            android:background=&quot;@drawable/ic_close&quot; /&gt;
    &lt;/RelativeLayout&gt;

    &lt;LinearLayout
        android:layout_width=&quot;match_parent&quot;
        android:layout_height=&quot;wrap_content&quot;
        android:layout_marginTop=&quot;15dp&quot;
        android:orientation=&quot;vertical&quot;
         &gt;

        &lt;TableLayout
            android:layout_width=&quot;match_parent&quot;
            android:layout_height=&quot;20dip&quot;
            android:layout_marginBottom=&quot;2dip&quot;
            android:layout_marginTop=&quot;2dip&quot; &gt;

            &lt;TableRow&gt;

                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/sunday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;

                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/monday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;
                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/thesday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;

                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/wednesday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;

                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/thursday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;

                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/friday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;

                &lt;TextView
                    style=&quot;@style/dateStyle&quot;
                    android:text=&quot;@string/saturday&quot;
                    android:textColor=&quot;@color/canlendar_text_color&quot; /&gt;
            &lt;/TableRow&gt;
        &lt;/TableLayout&gt;
    &lt;/LinearLayout&gt;

    &lt;LinearLayout
        android:layout_width=&quot;match_parent&quot;
        android:layout_height=&quot;0dp&quot;
        android:orientation=&quot;vertical&quot;
        android:layout_weight=&quot;1&quot;
        android:layout_marginTop=&quot;15dp&quot;&gt;

        &lt;android.support.v4.view.ViewPager
            android:id=&quot;@+id/vp_calendar&quot;
            android:layout_width=&quot;match_parent&quot;
            android:layout_height=&quot;wrap_content&quot;
            android:layout_gravity=&quot;center&quot;
            android:background=&quot;@color/white&quot; &gt;
        &lt;/android.support.v4.view.ViewPager&gt;
    &lt;/LinearLayout&gt;

&lt;/LinearLayout&gt;</pre>
<p>/CustomCalendarView/src/com/xiaowu/calendar/MainActivity.java</p>
<pre>package com.xiaowu.calendar;

import android.app.Activity;
import android.os.Bundle;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.ImageButton;
import android.widget.TextView;

import com.xiaowu.calendar.CalendarCard.OnCellClickListener;

public class MainActivity extends Activity implements OnClickListener, OnCellClickListener{
	private ViewPager mViewPager;
	private int mCurrentIndex = 498;
	private CalendarCard[] mShowViews;
	private CalendarViewAdapter&lt;CalendarCard&gt; adapter;
	private SildeDirection mDirection = SildeDirection.NO_SILDE;
	enum SildeDirection {
		RIGHT, LEFT, NO_SILDE;
	}

	private ImageButton preImgBtn, nextImgBtn;
	private TextView monthText;
	private ImageButton closeImgBtn;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_main);
		mViewPager = (ViewPager) this.findViewById(R.id.vp_calendar);
		preImgBtn = (ImageButton) this.findViewById(R.id.btnPreMonth);
		nextImgBtn = (ImageButton) this.findViewById(R.id.btnNextMonth);
		monthText = (TextView) this.findViewById(R.id.tvCurrentMonth);
		closeImgBtn = (ImageButton) this.findViewById(R.id.btnClose);
		preImgBtn.setOnClickListener(this);
		nextImgBtn.setOnClickListener(this);
		closeImgBtn.setOnClickListener(this);

		CalendarCard[] views = new CalendarCard[3];
		for (int i = 0; i &lt; 3; i++) {
			views[i] = new CalendarCard(this, this);
		}
		adapter = new CalendarViewAdapter&lt;&gt;(views);
		setViewPager();

	}

	private void setViewPager() {
		mViewPager.setAdapter(adapter);
		mViewPager.setCurrentItem(498);
		mViewPager.setOnPageChangeListener(new OnPageChangeListener() {

			@Override
			public void onPageSelected(int position) {
				measureDirection(position);
				updateCalendarView(position);
			}

			@Override
			public void onPageScrolled(int arg0, float arg1, int arg2) {

			}

			@Override
			public void onPageScrollStateChanged(int arg0) {

			}
		});
	}

	@Override
	public void onClick(View v) {
		switch (v.getId()) {
		case R.id.btnPreMonth:
			mViewPager.setCurrentItem(mViewPager.getCurrentItem() - 1);
			break;
		case R.id.btnNextMonth:
			mViewPager.setCurrentItem(mViewPager.getCurrentItem() + 1);
			break;
		case R.id.btnClose:
			finish();
			break;
		default:
			break;
		}
	}

	@Override
	public void clickDate(CustomDate date) {

	}

	@Override
	public void changeDate(CustomDate date) {
		monthText.setText(date.month + &quot;月&quot;);
	}

	/**
	 * 计算方向
	 *
	 * @param arg0
	 */
	private void measureDirection(int arg0) {

		if (arg0 &gt; mCurrentIndex) {
			mDirection = SildeDirection.RIGHT;

		} else if (arg0 &lt; mCurrentIndex) {
			mDirection = SildeDirection.LEFT;
		}
		mCurrentIndex = arg0;
	}

	// 更新日历视图
	private void updateCalendarView(int arg0) {
		mShowViews = adapter.getAllItems();
		if (mDirection == SildeDirection.RIGHT) {
			mShowViews[arg0 % mShowViews.length].rightSlide();
		} else if (mDirection == SildeDirection.LEFT) {
			mShowViews[arg0 % mShowViews.length].leftSlide();
		}
		mDirection = SildeDirection.NO_SILDE;
	}

}
</pre>
<p>用到的资源：</p>
<p>/CustomCalendarView/res/values/color.xml</p>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;
&lt;resources&gt;
    &lt;color name=&quot;white&quot;&gt;#ffffff&lt;/color&gt;
     &lt;color name=&quot;canlendar_text_color&quot;&gt;#323232&lt;/color&gt;
&lt;/resources&gt;
</pre>
<p>/CustomCalendarView/res/values/strings.xml</p>
<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;
&lt;resources&gt;

    &lt;string name=&quot;app_name&quot;&gt;CustomCalendarView&lt;/string&gt;
    &lt;string name=&quot;hello_world&quot;&gt;Hello world!&lt;/string&gt;
    &lt;string name=&quot;action_settings&quot;&gt;Settings&lt;/string&gt;

    &lt;string name=&quot;sunday&quot;&gt;日&lt;/string&gt;
    &lt;string name=&quot;monday&quot;&gt;一&lt;/string&gt;
    &lt;string name=&quot;thesday&quot;&gt;二&lt;/string&gt;
    &lt;string name=&quot;wednesday&quot;&gt;三&lt;/string&gt;
    &lt;string name=&quot;thursday&quot;&gt;四&lt;/string&gt;
    &lt;string name=&quot;friday&quot;&gt;五&lt;/string&gt;
    &lt;string name=&quot;saturday&quot;&gt;六&lt;/string&gt;

&lt;/resources&gt;
</pre>
<p>/CustomCalendarView/res/values/styles.xml</p>
<pre>&lt;resources&gt;

    &lt;!--
        Base application theme, dependent on API level. This theme is replaced
        by AppBaseTheme from res/values-vXX/styles.xml on newer devices.
    --&gt;
    &lt;style name=&quot;AppBaseTheme&quot; parent=&quot;android:Theme.Light&quot;&gt;
        &lt;!--
            Theme customizations available in newer API levels can go in
            res/values-vXX/styles.xml, while customizations related to
            backward-compatibility can go here.
        --&gt;
    &lt;/style&gt;

    &lt;!-- Application theme. --&gt;
    &lt;style name=&quot;AppTheme&quot; parent=&quot;AppBaseTheme&quot;&gt;
        &lt;!-- All customizations that are NOT specific to a particular API-level can go here. --&gt;
    &lt;/style&gt;

    &lt;style name=&quot;dateStyle&quot;&gt;
        &lt;item name=&quot;android:layout_width&quot;&gt;fill_parent&lt;/item&gt;
        &lt;item name=&quot;android:layout_height&quot;&gt;fill_parent&lt;/item&gt;
        &lt;item name=&quot;android:layout_weight&quot;&gt;1&lt;/item&gt;
        &lt;item name=&quot;android:gravity&quot;&gt;center&lt;/item&gt;
        &lt;item name=&quot;android:textSize&quot;&gt;16sp&lt;/item&gt;
    &lt;/style&gt;

&lt;/resources&gt;
</pre>
<p>源码下载：<a href="http://download.csdn.net/detail/wwj_748/8312233" rel="external nofollow noreferrer">http://download.csdn.net/detail/wwj_748/8312233</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 09:46:13 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/android/" title="android">android</a>, <a href="https://www.biecuoliao.com/tag/%e6%97%a5%e5%8e%86/" title="日历">日历</a>, <a href="https://www.biecuoliao.com/tag/it_xiao%e5%b0%8f%e5%b7%ab/" title="it&lowbar;xiao小巫">it&lowbar;xiao小巫</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android UI-自定义日历控件的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgZg2O4.html" rel="bookmark">Android自定义控件之日历控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android自定义控件之日历控件 2015-10-23 Android开发中文站 三月份学习android,至今也有半年有余,中间也做过两个项目,但是依然感觉自己做的应用不是很有新意,比不上应用市场上那些应用如此绚丽.所以自己仍需继续努力.学习至今,仍感觉自定义控件是一块硬骨头,还没修炼到身后的内功,下面就切入正题,以一次项目的需求,来实现一个自定义的日历控件.效果图先来一发. 我们分析下效果图,然后确定我们的需求. (1).绘制星期的自定义View,用于标识日期的礼拜. (2).绘制日期的自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWrO1a4.html" rel="bookmark">自定义日历控件-CalendarView</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处: http://blog.csdn.net/forwardyzk/article/details/43056675 我们在开发中会遇到使用到日历控件,下面就介绍一个自定义日历控件. 思路: 1.自定义类CalendarView继承LinearLayout,使用布局文件,显示布局. 2.使用ViewFlipper,里面添加GridView,当月的日期. 3.使用手势GestureDetector,控制ViewFlipper的滑动. calen_calendar.xml &lt;span			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGAYBG3.html" rel="bookmark">javascript实例学习之六&mdash;自定义日历控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于之前上篇博客轻量级jquery,tool.js和base.js.自定义开发的base_datePicker插件,效果类似于jquery_ui的datePicker插件 //基于Base.js以及tool.js做的日历插件 $().extend('datePicker', function() { //生成日历插件 var $yearSpan; var $monthSpan; var tds; var $prevBtn; var $nextBtn; var $lastTr; var $date			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vOQla4.html" rel="bookmark">安卓自定义日历控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				尊重作者劳动成果,转载请注明出处:http://blog.csdn.net/baiyuliang2013/article/details/37732149 最近,因工作需要,需要实现自定义日历控件功能,主要应用于软件中的酒店入住时间选择功能,进入日历后,可选择入住时间,及离开时间,选择完成后,再次进入日历时,会显示上次选中的结果,默认选择日期是在距当前日期三个月内,三个月以外的均以灰色显示,且不可点击.本篇实现的效果是高仿某软件的界面效果: 某软件界面效果: 本篇实现的效果: 另外,对于日期选择			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mym2ajM.html" rel="bookmark">android 自定义日历控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				日历控件View: [java] view plaincopyprint? /** * 日历控件 功能:获得点选的日期区间 * */ public class CalendarView extends View implements View.OnTouchListener { private final static String TAG = &quot;anCalendar&quot;; private Date selectedStartDate; private Date selectedEndD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0aGWXk4.html" rel="bookmark">【无私分享】干货！！！一个炫酷的自定义日历控件，摆脱日历时间选择烦恼，纯福利~</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近公司项目中有一个按日期查看信息的功能,楼主本想用之前用的wheelView将就使用的,不过产品经理有个新要求,就是点击按钮弹出的日期选择对话框必须显示农历节假日,周几什么的.这可就难为人了,倘若使用之前的滚动时间选择器,无疑是难以实现的,楼主辗转反侧,冥思苦想,却不得正果. 好吧,去网上下了几个OA系统一用就有了idea,突然想到手机自带的日历~~,oh,year,日历就有这功能,瞧瞧,我靠,这个东西,咋做. 仔细一瞧,似乎用GridView可以实现,额,二话不说就开干.折腾了半天都没弄好,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDZXB83.html" rel="bookmark">IOS自定义日历控件的简单实现&lpar;附思想及过程&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				因为程序要求要插入一个日历控件,该空间的要求是从当天开始及以后的六个月内的日历,上网查资料基本上都说只要获取两个条件(当月第一天周几和本月一共有多少天)就可以实现一个简单的日历,剩下的靠自己的简单逻辑就OK了,下面开始自己从开始到完成的整个过程 1,首先做NSDate类目,扩展一些方法让日期之间转换更加方便 #import &lt;Foundation/Foundation.h&gt; @interface NSDate (LYWCalendar) #pragma mark - 获取日 - (NSInte			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38kERn0.html" rel="bookmark">Android自定义控件&mdash;&mdash;自定义组合控件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处http://blog.csdn.net/allen315410/article/details/39581055  前面几篇博文介绍了Android如何自定义控件,其实就是讲一下如何&quot;从无到有&quot;的自定义一个全新的控件,继承View或者继承ViewGroup,复写其相关方法,这种自定义控件的方式相对来说难度较大,而且并不是所有需要新控件的情况下,都要这样进行.有很多情况下,我们只要运用好Android给我提供好的控件,经过布局巧妙的结合在一起,就是一个新的控件,我称之为&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kwmBP0.html" rel="bookmark">android：自定义组合控件Weight&lpar;高仿猫眼底部菜单栏&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在我们实际开发当中,会碰见一些布局结构类似或者相同的界面,例如应用的设置界面.tab按钮界面等.这时候,对于初学者来说,xml里面一个个绘制出来或许是最初的想法:可能随着经验的积累,又学会一招,就是使用include标签,导入类似或者相同的布局,提高了性能又减少了代码:再以后呢,自定义控件又可以实现这一目的.本文就是简单的使用自定义的组合控件模仿猫眼底部菜单栏. 1.自定义组合控件属性:在res/values目录下创建attrs.xml文件 &lt;declare-styleable name=&quot			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4Jzan4.html" rel="bookmark" class="title">20145216 史婧瑶《信息安全系统设计基础》第一周学习总结</a>
					<div>
						20145216 &lt;信息安全系统设计基础&gt;第一周学习总结 教材学习内容总结 Linux基础 1.ls命令 ls或ls .显示是当前目录的内容,这里“.”就是参数,表示当前目录,是缺省的可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/bMobxx4.html" rel="bookmark" class="title">UVA 1585 字符串处理</a>
					<div>
						背景:小紫书上习题 学习:1.条件运算符?:: 的运用可以简化,高效代码.?的优先级大于=,小余算术和关系运算符.与多重赋值语句一样采用右结合.(用到了dp的思想) 代码: #include&lt;s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P47lN1M.html" rel="bookmark" class="title">hbase 基本命令</a>
					<div>
						1.用shell来连接HBase [[email protected] bin]# cd /usr/hadoop/hbase-1.1.7/bin [[email protected] bin]# ./ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35gqjM.html" rel="bookmark" class="title">面向对象第四天</a>
					<div>
						总感觉今天的学习效率不高,好多东西都不知道,像傻了一样.总结了一下今天的知识点,都是很琐碎的东西,为了以后还是决定记录一下. 一.上次课知识点补充 1.delete 可以删除对象的指定属性.  注意: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lrqlN4.html" rel="bookmark" class="title">论文写作之参考文献的标注</a>
					<div>
						今天发现一个让参考文献的标注更加方便的方法,我之前不知道.手动标注太麻烦,然后就去搜简单的方法.结果发现了,方法还有好多种,这里说一种比较好用的.从这件事我又明白一个道理,有需求就有创造啊. 第一步: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bnDWo0.html" rel="bookmark" class="title">HTML&mdash;&mdash;body元素</a>
					<div>
						.&lt;body&gt;&lt;/body&gt; 2.&lt;body&gt;元素中可以使用的属性: 属性名称 写法 文本显示方向 dir 指定语言 lang 背景图片 background 背景 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eqQJ50.html" rel="bookmark" class="title">震撼&comma;强烈推荐 OrangeUI For FireMonkey</a>
					<div>
						今天,高勇上传了一个演示rtx for kbmMW的android应用,我下载测试,被实际的效果给震惊了!万万想不到的,用OrangeUI做的一个List列表,数据通过远程查询,运行效果在我看来,达到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NALdw3.html" rel="bookmark" class="title">UIView 中bounds和frame的差别</a>
					<div>
						搞iOS开发的童鞋基本都会用过UIView,那他的bounds和frame两个属性也不会陌生,那这两个有什么实质性的区别呢? 先看到下面的代码你肯定就明白了一些: -(CGRect)frame{    ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vKAJa4.html" rel="bookmark" class="title">every moment is a gift with a new opportunity in one chance&period;&sol;停下来，去感知</a>
					<div>
						就把它当作一个事实,不要去分析. as long as you are alive, God bless you, you owe him 文中强调要停下来,去感知.自我意识是一个人唯一的武器和依靠. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYGZpM.html" rel="bookmark" class="title">&lbrack;原&rsqb;Unity3D深入浅出 - 认识开发环境中的RenderSettings面板</a>
					<div>
						Fog:在Scene中开启雾效果 Fog Color:雾的颜色 Fog Mode:雾效果的模式,Linear(线性雾效果) Exponential(均匀分布的雾效果)  Exp2(越远越看不清楚)三种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vKkbj4.html" rel="bookmark" class="title">Laravel5&period;1  模型--删除</a>
					<div>
						今天我们来看看如何删除数据 delete删除模型 获取到模型,执行delete方法就好: public function destroy($id) { $article = Article::find ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONdqG0.html" rel="bookmark" class="title">第四五周（3&period;28-4&period;10）进度及下周计划（4&period;10组会总结）</a>
					<div>
						进度: 我们完成了第一部分内容,即数据爬取和自然语言初步处理 下周计划:   完善情感词库,进一步情感分析  开始写工程的WEB界面 爬取的数据都来自东方财富网的股吧,包括标题,内容,作者,时间,以及 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NabaZ3.html" rel="bookmark" class="title">HDU2074 叠筐【图形打印】</a>
					<div>
						题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=2074 题目大意: 打印一个两种花色层层交错的图形.给你最外环的尺寸N和两个字符表示花色A(中心 花色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAYJYM.html" rel="bookmark" class="title">Javascript实战开发：教你使用raphael&period;js绘制中国地图</a>
					<div>
						最近的数据统计项目中要用到中国地图,也就是在地图上动态的显示某个时间段某个省份地区的统计数据,我们不需要flash,仅仅依靠raphael.js以及SVG图像就可以完成地图的交互操作.在本文中,我给大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODVlg4.html" rel="bookmark" class="title">怪异JS错误的诊断与修复</a>
					<div>
						h2{font-size:1.2em}p{text-indent:2em;}前端开发whqet,csdn,王海庆,whqet,前端开发专家 原文:JavaScript Errors and How t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDymX80.html" rel="bookmark" class="title">不使用JS实现表单验证</a>
					<div>
						我们可以给表单元素添加required,pattern属性,还有根据具体元素类型决定的Measureable属性,如:min,max等. required:表示必填. pattern:一般用于type ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPyRj4.html" rel="bookmark" class="title">linux下 signal信号机制的透彻分析与各种实例讲解</a>
					<div>
						转自:http://blog.sina.com.cn/s/blog_636a55070101vs2d.html 转自:http://blog.csdn.net/tiany524/article/det ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JvGRn4.html" rel="bookmark" class="title">二叉树基础（创建方法，遍历方法&lpar;前序&sol;中序&sol;后序&sol;层序、递归&sol;非递归）</a>
					<div>
						二叉树的创建及遍历是很多二叉树问题的基础,递归遍历逻辑清晰,代码简约漂亮,然则效率低下(所有递归方案的通病,非不得已不用递归): 非递归遍历高效,却不是能信手写出来的,特别是后续非递归遍历,相信很多资 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVvZYdM.html" rel="bookmark" class="title">jquery调用angular函数</a>
					<div>
						&lt;div id=&quot;mycontroller&quot; ng-controller=&quot;mycontroller&quot;&gt;&lt;/div&gt; var $scop ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qOn57M.html" rel="bookmark" class="title">VxWorks kernel application</a>
					<div>
						#1 什么是内核应用程序? #2 开发内核应用程序注意事项 什么是内核应用程序? 内核应用程序不同于RTP程序,它允许在内核态,与操作系统使用相同的地址空间.因此,它与操作系统会相互干扰.它可以编译成 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
